<template>
    <div class="d-flex align-items-center" style="gap:5px;">
        <button 
            v-if="
            $auth.hasPermission(config.permissions.order_write) && 
            order.order_status == statuses.placed" 
            class="btn accept-btn"
            @click="changeStatus(order.base_id,statuses.inkitchen)"
            :disabled="isAcceptbtnDisabled">
            <i class="fas fa-check"></i>
            <!-- v-b-tooltip.hover.v-light :title="trans.get('__JSON__.Confirm Order')" -->
        </button>
        <button 
            v-if="
            $auth.hasPermission(config.permissions.order_write) && 
            [statuses.placed,statuses.inkitchen,statuses.readytoserve,statuses.ontheway,statuses.scheduled].includes(order.order_status) && order.is_dunzo_driver == '0'" 
            class="btn reject-btn"
            @click="cancelOrderPopup(order.base_id,statuses.cancelled)">
            <i class="fas fa-times"></i>
        </button>
        <!-- v-b-tooltip.hover.v-light :title="trans.get('__JSON__.Cancel Order')" -->
        <button 
            v-if="
            $auth.hasPermission(config.permissions.order_write) && 
            [statuses.placed,statuses.inkitchen,statuses.readytoserve,statuses.ontheway,statuses.scheduled].includes(order.order_status) && order.is_dunzo_driver == '1' && checkDunzoOrder()" 
            class="btn reject-btn"
            @click="cancelOrderPopup(order.base_id,statuses.cancelled)">
            <i class="fas fa-times"></i>
            <!-- v-b-tooltip.hover.v-light :title="trans.get('__JSON__.Cancel Order')" -->
        </button>
        <b-dropdown lazy id="dropdown-1" variant="link" right role="navigation" class="order-option-dropdown" v-if="$auth.hasPermission(config.permissions.order_write)">
            <template #button-content>
                <i class="bx bx-dots-vertical-rounded"></i>
            </template>
            <!-- v-b-tooltip.hover.v-light title="More" -->
            <b-dropdown-item v-if="[statuses.paymentfailure,statuses.paymentpending].includes(order.order_status) && isCODEnable()" @click="changeToCODPopup(order.base_id)">
                {{trans.get('__JSON__.Change to COD')}}
            </b-dropdown-item>
            <b-dropdown-item  @click="viewDetails(order.base_id)">{{trans.get('__JSON__.View')}}</b-dropdown-item>
            <b-dropdown-item v-if="order.order_status == statuses.placed" @click="changeStatus(order.base_id,statuses.inkitchen)">{{trans.get('__JSON__.Confirm Order')}}</b-dropdown-item>
            <b-dropdown-item v-if="order.order_status == statuses.inkitchen" @click="changeStatus(order.base_id,statuses.readytoserve)">{{trans.get('__JSON__.Ready To Delivery Order')}}</b-dropdown-item>
            <b-dropdown-divider v-if="[statuses.placed,statuses.inkitchen,statuses.readytoserve,statuses.ontheway, statuses.scheduled].includes(order.order_status)"></b-dropdown-divider>
            
            <b-dropdown-item v-if="
                [statuses.readytoserve].includes(order.order_status) &&
                (order.driver && order.driver.length == 0) &&
                order.delivery_pickup_types == 'Delivery' &&
                order.is_dunzo_driver == '0' && order.is_load_sharing_driver == '0'"
                @click="pingOrderDrivers(order.base_id)">
                Ping {{$auth.getDriverName()}}
            </b-dropdown-item>
            

            <b-dropdown-item v-if="[statuses.readytoserve,statuses.ontheway].includes(order.order_status)" @click="deliveredOrderPopup(order.base_id,statuses.delivered)" >{{trans.get('__JSON__.Deliver Order')}}</b-dropdown-item>
            <b-dropdown-item v-if="[statuses.placed,statuses.inkitchen,statuses.readytoserve,statuses.ontheway, statuses.scheduled].includes(order.order_status) && order.is_dunzo_driver == '0' && order.is_load_sharing_driver == '0' " @click="cancelOrderPopup(order.base_id,statuses.cancelled)" ><span class="text-danger">{{trans.get('__JSON__.Cancel Order')}}</span></b-dropdown-item>
            <b-dropdown-item v-if="[statuses.placed,statuses.inkitchen,statuses.readytoserve,statuses.ontheway, statuses.scheduled].includes(order.order_status) && order.is_dunzo_driver == '1' && order.is_load_sharing_driver == '0' && checkDunzoOrder()" @click="cancelOrderPopup(order.base_id,statuses.cancelled)" ><span class="text-danger">{{trans.get('__JSON__.Cancel Order')}}</span></b-dropdown-item>
            <!-- <b-dropdown-item v-if="[statuses.placed,statuses.inkitchen,statuses.readytoserve,statuses.ontheway, statuses.scheduled].includes(order.order_status) && order.is_dunzo_driver == '0' && order.is_load_sharing_driver == '0'" @click="cancelOrderPopup(order.base_id,statuses.cancelled)" ><span class="text-danger">{{trans.get('__JSON__.Cancel Order')}}</span></b-dropdown-item> -->
            <b-dropdown-item v-if="[statuses.placed,statuses.inkitchen,statuses.readytoserve,statuses.ontheway, statuses.scheduled].includes(order.order_status) && order.is_dunzo_driver == '0' && order.is_load_sharing_driver == '1'" @click="cancelOrderPopup(order.base_id,statuses.cancelled)" ><span class="text-danger">{{trans.get('__JSON__.Cancel Order')}}</span></b-dropdown-item>
        </b-dropdown>
        <i v-else v-b-tooltip="'Need Permission'" class="mdi mdi-information h4 text-danger"></i>
        <OrderShow v-if="showModal"  :order-id="order.base_id" @hidden="showModal = false" />
        <b-modal
            id="modal-sm"
            size="lg"
            title-class="font-18"
            @hidden="resetModal"
            @ok="cancelOrder"
            :ok-disabled="loading"
            :ok-title="loading?trans.get('__JSON__.Cancelling'):trans.get('__JSON__.Cancel Order')"
            ok-only
            ok-variant="danger"
            ref="cancel-modal"
            lazy
            >
            <template #modal-header={close}>
                <div class="d-flex justify-content-between w-100">
                    <h4 class="mb-0">{{trans.get('__JSON__.Cancel Order')}}</h4>
                    <h4 class="mb-0">{{order.order_id}}</h4>
                </div>
                <button type="button" aria-label="Close" class="close" @click="close()">&times;</button>
            </template>

            <div class="row">
                <div class="col-12">
                    <b-form role="form">
                        <div class="row">
                            <div class="col" v-for="(reason, index) in cancel_reasons" :key="index">
                                <a href="#" @click="onReasonSelect(reason)">
                                <b-card header-class="bg-transparent border-primary" class="border border-primary"
                                    :bg-variant="other_selected && reason == 'Other' || reason == cancelled_desc ? 'primary' : 'default'"
                                     body-class="d-flex align-items-center justify-content-center height-100">
                                    <h5 class="card-title mt-0" :class="{'text-white': (other_selected && reason == 'Other' || reason == cancelled_desc)}">{{reason}}</h5>
                                </b-card>
                                </a>
                            </div>
                        </div>
                        <b-form-group label="Cancel Description" v-if="other_selected">
                             <b-form-textarea
                                id="textarea"
                                v-model="cancelled_desc"
                                placeholder="Enter Cancel Order Description"
                                rows="3"
                                max-rows="6"
                                ></b-form-textarea>
                        </b-form-group>
                        <b-form-group v-if="!$auth.partner_login && !(order.payment_method == 'Cash On Delivery' && order.wallet_amount == 0)">
                            <b-form-select v-model="is_refundable" :options="[
                                { value: '0', text: 'No Refundable' },
                                ...(order.payment_method == 'Online'?[{ value: '1', text: 'Refundable - Original Payment' }]:[]),
                                ...(order.payment_method == 'Online' || order.payment_method == 'Wallet' || (order.payment_method == 'Cash On Delivery' && order.wallet_amount > 0)?[{ value: '2', text: 'Refundable - to Wallet' }]:[]),
                            ]"></b-form-select>
                        </b-form-group>
                        <!-- <b-form-group v-else-if="!$auth.partner_login">
                             <b-form-checkbox
                                id="checkbox-1"
                                switch
                                v-model="is_refundable"
                                class="text-right"
                                name="checkbox-1"
                                size="lg"
                                value="1"
                                unchecked-value="0"
                            >
                            Is Refundable
                            </b-form-checkbox>
                        </b-form-group> -->
                    </b-form>
                </div>
            </div>
        </b-modal>

        <b-modal
            id="modal-sm"
            size="lg"
            title-class="font-18"
            @hidden="resetModal"
            @ok="deliveredOrder"
            :ok-disabled="loading"
            :ok-title="loading?trans.get('__JSON__.Delivering'):trans.get('__JSON__.Deliver Order')"
            ok-only
            ok-variant="danger"
            ref="delivered-modal"
            lazy
            >
            <template #modal-header={close}>
                <div class="d-flex justify-content-between w-100">
                    <h4 class="mb-0">{{trans.get('__JSON__.Deliver Order')}}</h4>
                    <h4 class="mb-0">{{order.order_id}}</h4>
                </div>
                <button type="button" aria-label="Close" class="close" @click="close()">&times;</button>
            </template>

            <div class="row">
                <div class="col-12">
                    <b-form role="form">
                        <b-form-group label="Notes">
                             <b-form-textarea
                                id="textarea"
                                v-model="delivered_note"
                                placeholder="Enter something..."
                                rows="3"
                                max-rows="6"
                                ></b-form-textarea>
                        </b-form-group>
                    </b-form>
                </div>
            </div>
        </b-modal>

        <b-modal
            id="modal-sm"
            size="lg"
            title-class="font-18"
            @hidden="resetModal"
            @ok="changeToCODOrder"
            :ok-disabled="loading"
            :ok-title="loading?trans.get('__JSON__.Change to COD'):trans.get('__JSON__.Change to COD')"
            ok-only
            ok-variant="danger"
            ref="changeto-cod-modal"
            lazy
            >
            <template #modal-header={close}>
                <div class="d-flex justify-content-between w-100">
                    <h4 class="mb-0">{{trans.get('__JSON__.Change to COD')}}</h4>
                    <h4 class="mb-0">{{order.order_id}}</h4>
                </div>
                <button type="button" aria-label="Close" class="close" @click="close()">&times;</button>
            </template>

            <div class="row">
                <div class="col-12">
                    <b-form role="form">
                        <b-form-group label="Notes">
                             <b-form-textarea
                                id="textarea"
                                v-model="changeto_cod_note"
                                placeholder="Enter something..."
                                rows="3"
                                max-rows="6"
                                ></b-form-textarea>
                        </b-form-group>
                    </b-form>
                </div>
            </div>
        </b-modal>
    </div>
</template>

<script>
import OrderShow from './order-show';
import {debounce, order_statuses} from './../../../Helper/helper'
import config from '../../../config';
import { orderService } from '../../../services';

export default {
    props: [ 'order'],
    components : { OrderShow },
    data(){
        return {
            config: config,
            showModal: false,
            statuses: order_statuses,
            dunzostatus: dunzoorder_statuses,
            cancelled_desc: '',
            delivered_note: '',
            changeto_cod_note: '',
            is_refundable: this.$auth.partner_login?1:0,
            showPopup: false,
            order_id: null,
            cancel_reasons:[
                'Too Busy',
                'Out of Delivery Area',
                'Out of Stock',
                'Other'
            ],
            other_selected: false,
            loading:false,
            isAcceptbtnDisabled:false
            // cancelThisOrder:debounce((bvModalEvt)=>{
            //     bvModalEvt.preventDefault()
            //     this.cancelOrder(bvModalEvt)
            // })
        }
    },
    created() {
        this.$root.$refs.order_action = this;
    },
    methods:{
        checkDunzoOrder() {
            if (this.order.is_dunzo_driver == '1') {
                if (this.order.dunzo_driver) {
                    if ([this.dunzostatus.created, this.dunzostatus.queued, this.dunzostatus.runnerAccepted, this.dunzostatus.reachedForPickup].includes(this.order.dunzo_driver.status)) {
                        return true;
                    }
                } else {
                    return true;
                }
            } else if (this.order.is_dunzo_driver == '0') {
                return true;
            }
            return false;
        },
        viewDetails(id){
            this.showModal = true;
            this.orderLoading = true;
            this.orderId = id;
        },
        changeStatus(id,status){            
            if (status == 'InKitchen') {
                this.isAcceptbtnDisabled = true;
            }
            const data = {order_id:atob(id),status_name:status,vendor_id:this.$auth.getVendorId(),is_langauge: this.$auth.setting.primary_lang};            
            orderService.changeOrderStatus(data)
            .then(response => {
                if(response.data.code == 200){
                    this.$toasted.success(response.data.msg);
                }else{
                    this.$toasted.error(response.data.msg);
                }
                // if (status == 'InKitchen') {
                //     this.isAcceptbtnDisabled = false;
                // }
                this.$emit('actionChanged');
            })
        },
        pingOrderDrivers(id){
            const data = {order_id:atob(id),vendor_id:this.$auth.getVendorId(),is_langauge: this.$auth.setting.primary_lang};
            orderService.pingOrderDrivers(data)
            .then(response => {
                if(response.data.code == 200){
                    this.$toasted.success(response.data.msg);
                }else{
                    this.$toasted.error(response.data.msg);
                }
            });
        },
        ownerOrderStatus(id,status){
            const data = {order_id:atob(id),status_name:status,vendor_id:this.$auth.getVendorId()};
            orderService.ownerOrderStatus(data)
                .then(response => {
                    if(response.data.code == 200){
                        this.$toasted.success(response.data.msg);
                    }else{
                        this.$toasted.error(response.data.msg);
                    }
                    this.$emit('actionChanged');
                })
        },
        resetModal(){
            this.order_id = null;
            this.is_refundable = this.$auth.partner_login?1:0;
            this.delivered_note = '';
            this.changeto_cod_note = '';
        },
        cancelOrderPopup(id,status){
            this.$refs['cancel-modal'].show();
            this.order_id = id;
        },
        cancelOrder(bvModalEvt){
            bvModalEvt.preventDefault()
            this.loading = true;
            if(this.cancelled_desc == ''){
                this.loading = false;
                if(this.other_selected){
                    this.$toasted.info('Please Enter Cancel Order Description');
                }else{
                    this.$toasted.info('Please Select Cancel Option');
                }
                return false;
            }
            const data = {orderId:atob(this.order_id),cancelled_desc:this.cancelled_desc, is_refundable:this.is_refundable};
            orderService.cancelOrder(data)
                .then(response => {
                    if(response.data.code == 200){
                        this.$toasted.success(response.data.message);
                    }else{
                        this.$toasted.error(response.data.message);
                    }
                    this.loading = false;
                    this.$refs['cancel-modal'].hide();
                    this.$emit('actionChanged');
                })
        },
        deliveredOrderPopup(id,status) {
            this.$refs['delivered-modal'].show();
            this.order_id = id;
        },
        deliveredOrder(bvModalEvt) {
            bvModalEvt.preventDefault()
            this.loading = true;
            if(this.delivered_note == ''){
                this.$toasted.info('Please write deliver note.');
                this.loading = false;
                return false;
            }
            const data = {orderId:atob(this.order_id),delivered_note:this.delivered_note};
            orderService.deliverOrder(data)
            .then(response => {
                if(response.data.code == 200){
                    this.$toasted.success(response.data.message);
                }else{
                    this.$toasted.error(response.data.message);
                }
                this.loading = false;
                this.$refs['delivered-modal'].hide();
                this.$emit('actionChanged');
            })
        },
        changeToCODPopup(id) {
            this.$refs['changeto-cod-modal'].show();
            this.order_id = id;
        },
        changeToCODOrder(bvModalEvt) {
            bvModalEvt.preventDefault()
            this.loading = true;
            if(this.changeto_cod_note == ''){
                this.$toasted.info('Please write change to cod note.');
                this.loading = false;
                return false;
            }
            const data = {orderId:atob(this.order_id),changeto_cod_note:this.changeto_cod_note};
            orderService.changeToCodOrder(data)
            .then(response => {
                if (response.data.code == 200) {
                    this.$toasted.success(response.data.message);
                } else {
                    this.$toasted.error(response.data.message);
                }
                this.loading = false;
                this.$refs['changeto-cod-modal'].hide();
                this.$emit('actionChanged');
            });
        },
        onReasonSelect(reason){
            if(reason !== 'Other'){
                this.cancelled_desc = reason;
                this.other_selected = false;
            }else{
                this.other_selected = true;
                this.cancelled_desc = '';
            }
        },
        isCODEnable(){
            if (this.$auth.setting.restaurant_payment_option) {
                if (this.$auth.setting.restaurant_payment_option == 'Both' || this.$auth.setting.restaurant_payment_option == 'COD') {
                    return true;
                } else if (this.$auth.setting.restaurant_payment_option == 'Restaurant Select Payment Option') {
                    if (this.order.store_payment_option) {
                        if (this.order.store_payment_option == 'Both' || this.order.store_payment_option == 'COD') {
                            return true;
                        }
                    }
                }
            }
            return false
        }
    }
};
</script>
<style  scoped>
.height-100{
    height: 100px;
}
.accept-btn, .reject-btn {
    color: #fff;
    font-size: 16px;
    font-weight: 100;
    line-height: 0;
    border-radius: 50%;
}
.accept-btn {
    background-color: #34c38f;
    padding: 5px;
}
.reject-btn {
    background-color: #f46a6a;
    padding: 5px 7px 5px 7px;
}
.order-option-dropdown button {
    padding: 0;
}
</style>
